
/*
  http://www.arduino.cc/en/Tutorial/TFTDisplayText
  https://github.com/inflop/Countimer
 */

// Elenco colori
#define BLACK           0x0000
#define BLUE            0x001F
#define RED             0xF800
#define GREEN           0x07E0
#define CYAN            0x07FF
#define MAGENTA         0xF81F
#define YELLOW          0xFFE0 
#define WHITE           0xFFFF

#include <gfxfont.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SPITFT.h>
#include <Adafruit_SPITFT_Macros.h>
#include <Adafruit_ST7735.h>

// fonts
#include <Fonts/FreeMonoBoldOblique12pt7b.h>
#include <Fonts/FreeSerif9pt7b.h>
#include <Fonts/FreeMono12pt7b.h>

// libreria per il timer
#include "Countimer.h" // tempo di PTT
Countimer tUp;         // tempo di PTT

// libreria di comunicazione I2C
#include <Wire.h>

// definizione pin del display
#define TFT_CS     10
#define TFT_RST    8  // you can also connect this to the Arduino reset                     
#define TFT_DC     9

// definizione del display
Adafruit_ST7735 TFTscreen = Adafruit_ST7735(TFT_CS,  TFT_DC, TFT_RST);

// char array to print to the screen
char ID_RadioPrintout[4];
char PTT_StatusPrintout[4];
char Radio_NamePrintout[16];

// Definizione variabili per lo switch

// Nomi delle radio 
String Radio_1 = "Yaesu FTM-400";
String Radio_2 = "Yaesu FTM-100";
String Radio_3 = "Hytera MD-785";
String Radio_4 = "Elecraft K2  ";
String Radio_5 = "Icom IC 7300 ";
String Radio_6 = "   NO Radio  "; 

// pin A1 partitore per misura tensione

int ID_Radio = 0;   // nr della radio selezionata in arrivo via I2C
int PTT_Status = 0; // stato del PTT - 1 quando è premuto
int Curr_Radio=0;   // contiene il nr della radio corrente per verificare se è stata selezionata un'altra radio
int Curr_PTT=0;     // contiene il nr della radio corrente per verificare se è stato rilasciato il PTT
long timeout = 45;  // Tempo di TOT dopo il quale inizia il lampeggio del led TX - Inserire il nr di SECONDI

int Curr_Mic=0;
String Mic_KNW="Kenwood";
String Mic_ICOM="Icom";
String Mic_Yaesu="Yaesu";
String Versione="1.00";
float vout=4.95;
// ------------------------------------

// ---- ciclo setup

void setup() {

Serial.begin(9600);

// ----------- inizializzazione colloquio bus I2C
  Wire.begin(9); 
  // Attach a function to trigger when something is received.
  Wire.onReceive(receiveEvent);
// ---------- timer -----------------------------------
  tUp.setCounter(0, 4, 0, tUp.COUNT_UP, tUpComplete);
      // Call print_time1() method every 1s.
  tUp.setInterval(print_time1, 1000);
// ----------------------------------------------------  
// inizializzazione display
  TFTscreen.initR(INITR_BLACKTAB);   // initialize a ST7735S chip, black tab
  TFTscreen.fillScreen(ST7735_BLACK);
  //TFTscreen.setTextSize(2);

// pagina all'accensione
  TFTscreen.setRotation(1);
  WelcomePrintout(); // stampa welcome banner all'accensione
 
} // fine ciclo setup

// ---- ciclo loop

void loop() {

  tUp.run(); // aggiunta

if (PTT_Status==0) {
  

// ----------- Acquisizione scelta radio e caricamento del nome ----------

if (Curr_Radio !=ID_Radio) {
  
switch (ID_Radio) {
    case 6:            
      Radio_6.toCharArray(Radio_NamePrintout, 16); 
      //RadioPrintout();
      WelcomePrintout();
      break;
    case 1:                 
      Radio_1.toCharArray(Radio_NamePrintout, 16);
      //RadioPrintout();
   
      break;     
    case 2:              
      Radio_2.toCharArray(Radio_NamePrintout, 16); 
      //RadioPrintout();
      break;
    case 3:
      Radio_3.toCharArray(Radio_NamePrintout, 16); 
      //RadioPrintout();      
      break;
      case 4:                    
      Radio_4.toCharArray(Radio_NamePrintout, 16); 
      //RadioPrintout();     
      break;
    case 5:
      Radio_5.toCharArray(Radio_NamePrintout, 16); 
      //RadioPrintout();
      break;     
    default: 
      // if nothing else matches, do the default
      // default is optional
   
    break;
    
  } // fine switch

if (ID_Radio!=6) {
    RadioRxPrintout(); // chiamata alla funzione che scrive sul display
}

} // fine if Curr_Radio !=ID_Radio
 
 } // fine if PTT_Status==0

if (Curr_PTT !=PTT_Status) {              
        tUp.start(); // aggiunta FUNZIONA
        RadioRxPrintout();          
}

// ---------------- condizionamento del formato dei dati ricevuti via I2C ----------------------

  // conversione in formato stringa degli interi ricevuti via I2C  
  String ID_RadioVal = String(ID_Radio);
  String PTT_StatusVal = String(PTT_Status);
  
  // converte i numeri ricevuti via I2C in array per poterli stampare sul display
  ID_RadioVal.toCharArray(ID_RadioPrintout, 4);
  PTT_StatusVal.toCharArray(PTT_StatusPrintout, 4);
 
} // fine ciclo loop

// ----------------------------------------------------------
// --------------- FUNZIONI DI SERVIZIO ---------------------
// ----------------------------------------------------------

// Funzione che stampa sul display il welcome banner all'accensione

void WelcomePrintout(void) {

  TFTscreen.fillScreen(ST7735_BLACK);

  TFTscreen.setTextColor(ST7735_WHITE);
  TFTscreen.setTextSize(2);
  TFTscreen.setCursor(2,5);
  TFTscreen.print("Nessuna radio");
  TFTscreen.setCursor(10,23);  
  TFTscreen.print("selezionata");

  TFTscreen.setTextColor(ST7735_YELLOW);
  TFTscreen.setTextSize(2);
  TFTscreen.setCursor(5,80);
  TFTscreen.print("Mic:");
  TFTscreen.setCursor(50,80);
  TFTscreen.print(Mic_KNW);  

  TFTscreen.setTextColor(ST7735_WHITE);  
  TFTscreen.setTextSize(1);
  TFTscreen.setCursor(2,110);
  TFTscreen.print("Versione:");
  TFTscreen.setCursor(55,110);
  TFTscreen.print(Versione);
  
  TFTscreen.setCursor(100,110);
  TFTscreen.print("Volt:");
  TFTscreen.setCursor(130,110);  
  TFTscreen.print(vout,2);

  Curr_Radio=ID_Radio; 
}

// --------------------------------------------
// Funzione che stampa sul display

void RadioRxPrintout(void) {

// rotazione display
TFTscreen.setRotation(1);

// ----------- se PTT rilasciato --------------
if (PTT_Status==0) {

// ferma il timer
tUp.stop(); // aggiunta

 TFTscreen.fillScreen(ST7735_BLACK);
  TFTscreen.setTextSize(2);

 TFTscreen.setTextColor(ST7735_YELLOW);
 
  TFTscreen.setCursor(0,8);
  TFTscreen.print(Radio_NamePrintout);
 TFTscreen.setTextColor(ST7735_YELLOW);

  TFTscreen.setTextSize(5);


  TFTscreen.setTextColor(ST7735_BLUE);
  TFTscreen.setCursor(50,40);
  
  TFTscreen.print("RX");
 

} // fine if se PTT rilasciato

// ----------- se PTT premuto ------------
if (PTT_Status!=0) {

 //tUp.start(); // aggiunta
  
  
  TFTscreen.fillScreen(ST7735_BLACK);
  
  TFTscreen.setTextSize(2);
  
 TFTscreen.setTextColor(ST7735_YELLOW);
  
  TFTscreen.setCursor(0,8);
  TFTscreen.print(Radio_NamePrintout);
  
  TFTscreen.setTextSize(5);
  
TFTscreen.setTextColor(ST7735_RED);
  
  TFTscreen.setCursor(50,40);
  TFTscreen.print("TX");

} // fine if se PTT premuto

// ----------------- se non è stata selezionata nuova rdaio o cambiato lo stato del PTT il dsplay non viene ridisegnato
Curr_PTT=PTT_Status;
Curr_Radio=ID_Radio; 

} // fine funzione

// ----------- Funzione che ascolta il bus I2C  
void receiveEvent(int bytes) {
  ID_Radio = Wire.read();      // riceve il nr della radio selezionata via I2C
  PTT_Status = Wire.read();    // riceve lo stato del PTT via I2C
}
// --------------------------------------------

// ----------------- funzione che stampa il conteggio del tempo di PTT
void print_time1()
{
 
  TFTscreen.fillRect(0, 90, 160, 35,BLACK);

  TFTscreen.setCursor(6,100);
  TFTscreen.setTextSize(3);
  TFTscreen.setTextColor(ST7735_WHITE);
  TFTscreen.print(tUp.getCurrentTime());
 
}

// -------------------------
void tUpComplete()
{
  //digitalWrite(13, HIGH);
}
