/*
Статья "Цифровой VU meter с OLED дисплеем. Arduino проект для начинающих":
http://www.techn0man1ac.info/arduino/diy-digital-vumeter-oled-and-arduino
Видео "Arduino проект для начинающих. VU meter с OLED дисплеем. Techn0man1ac #2 "
https://youtu.be/qoLsynwssLI
За основу взят вот этот проект:
https://forum.arduino.cc/index.php?topic=403234.0

By Techn0man1ac
*/

#include "display.c"
#include <OLED_I2C.h> // Library: OLED_I2C http://www.rinkydinkelectronics.com/library.php?id=79

#include <Wire.h> 
#include <Bounce2.h>

// Definizione variabili per lo switch

const int buttonPin =  7; // pin al quale è connesso il pulsante di scelta radio altro capo a massa
const int Ptt_Pin = 6;    // pin al quale è connesso il contatto del PTT altro capo a massa

int ID_Radio = 0;   // variabile che contine la scelta corrente da pulsante
int PTT_Status = 0; // variabile che contine lo stato del PTT 1 = premuto
int PTT_StatusTemp = 0; // variabile che contine lo stato del PTT 1 = premuto


int Radio1_On    = 9; 
int Radio2_On    = 10;
int Radio3_On    = 11;
int Radio4_On    = 12;
int Radio5_On    = 13;
// int ledArray[]    = {9, 10, 11, 12,13};  // pin corrispondenti ai relè delle 5 radio (radio1-pin 9 e via di seguito)


// aggiungere pin A1 per riconoscimento microfono
// ------------------------------------

// OLED  myOLED(SDA, SCL, 8); // Arduino Nano SDA - pin A4, SCL - A5

OLED  myOLED(SDA, SCL, 8); // Arduino Nano SDA - pin A4, SCL - A5

#define analogInput 0 // В этой строчке задаётся аналоговый пин ардуино;
#define HighSens true // режим высокой чувствительности, достигается за счёт изменения опорного напряжения в 1.1 V, 
//может быть как включено true, так и выключено — false, рекомендую включить;
#define FASTADC true // ускорение работы ADC, для Arduino Nano/Uno/Pro Mini рекомендуется включить(true );
#define Sensitivity 1024 // чувствительность, это значение не может быть больше 1024, если Ваш источник аудиосигнала 
//выдаёт небольшое выходное напряжение, то можете попробовать в 2, 4 раза уменьшить это значение;
#define SampleWindow 15  // количество сэмплов, число в миллисекундах, чем оно меньше, тем шустрее дёргается стрелка, 
//по умолчанию 50, но я для себя подобрал 15-20, больше уже ардуина не тянет.

// defines for setting and clearing register bits
#ifndef cbi
#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
#endif
#ifndef sbi
#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))
#endif

//extern uint8_t VUMeter[];

int hMeter = 65;                      // horizontal center for needle animation
int vMeter = 85;                      // vertical center for needle animation (outside of dislay limits)
int rMeter = 80;                      // length of needle animation or arch of needle travel

int sample;

// -----------
Bounce debouncer = Bounce();            // attivazione debouncing
// -----------

void setup() {

pinMode(Radio1_On, OUTPUT);
pinMode(Radio2_On, OUTPUT);
pinMode(Radio3_On, OUTPUT);
pinMode(Radio4_On, OUTPUT);
pinMode(Radio5_On, OUTPUT);

Serial.begin(9600);

// --------------
// Inizializzazione dei PIN di input per il pulsante (e messa sotto debouncing) e per il PTT
  pinMode(buttonPin, INPUT_PULLUP);
  pinMode(Ptt_Pin, INPUT_PULLUP);
   
  debouncer.attach(buttonPin);
  debouncer.interval(5); // interval in ms
// --------------
Wire.begin(); // aggiunta

  if (HighSens == true) {  // Включить(true)/выключить(false) режим высокой чувствительности
    analogReference(INTERNAL);  //an built-in reference, equal to 1.1 volts on the ATmega168 or ATmega328 
    // and 2.56 volts on the ATmega8 (not available on the Arduino Mega)
    //INTERNAL1V1: a built-in 1.1V reference (Arduino Mega only)
  } else {
    analogReference(DEFAULT);
  }

#if FASTADC
  // set prescale to 16
  sbi(ADCSRA, ADPS2) ;
  cbi(ADCSRA, ADPS1) ;
  cbi(ADCSRA, ADPS0) ;
#endif

  myOLED.begin();          // needed for SH1106 display
  myOLED.clrScr();                                 // clears display from any library info displayed
}

// ---- ciclo loop

void loop() {

// Lettura dello stato del PTT
PTT_StatusTemp = digitalRead(Ptt_Pin);
  
// Inversione del valore perchè ho usato il contatto NA del relè PTT
  if (PTT_StatusTemp ==0 ) {
          PTT_Status = 1;                                
        }    
     
  if (PTT_StatusTemp ==1 ) {
          PTT_Status = 0;                                
        }
// ----------------------------------------------      
// Debouncing del pulsante

    debouncer.update();
    if (debouncer.rose())
    {

// lettura del pulsante di selezione Radio

if (digitalRead(buttonPin))
  {
    if (ID_Radio > 5)
      ID_Radio = 0;
    {
       switch (ID_Radio) {

        case 0: // attiva Radio 1                                  
         digitalWrite(Radio1_On, HIGH);
         digitalWrite(Radio2_On, LOW);
         digitalWrite(Radio3_On, LOW);
         digitalWrite(Radio4_On, LOW);
         digitalWrite(Radio5_On, LOW);            
        break;
        
        case 1: // attiva Radio 2
         digitalWrite(Radio1_On, LOW);
         digitalWrite(Radio2_On, HIGH);
         digitalWrite(Radio3_On, LOW);
         digitalWrite(Radio4_On, LOW);
         digitalWrite(Radio5_On, LOW);                                   
        break;

        case 2: // attiva Radio 3
         digitalWrite(Radio1_On, LOW);
         digitalWrite(Radio2_On, LOW);
         digitalWrite(Radio3_On, HIGH);
         digitalWrite(Radio4_On, LOW);
         digitalWrite(Radio5_On, LOW);                           
        break;
        
        case 3: // attiva Radio 4
         digitalWrite(Radio1_On, LOW);
         digitalWrite(Radio2_On, LOW);
         digitalWrite(Radio3_On, LOW);
         digitalWrite(Radio4_On, HIGH);
         digitalWrite(Radio5_On, LOW);                           
        break;

        case 4: // attiva Radio 5
         digitalWrite(Radio1_On, LOW);
         digitalWrite(Radio2_On, LOW);
         digitalWrite(Radio3_On, LOW);
         digitalWrite(Radio4_On, LOW);
         digitalWrite(Radio5_On, HIGH);                          
        break;

        case 5: // attiva Radio 5
         digitalWrite(Radio1_On, LOW);
         digitalWrite(Radio2_On, LOW);
         digitalWrite(Radio3_On, LOW);
         digitalWrite(Radio4_On, LOW);
         digitalWrite(Radio5_On, LOW);                          
        break;
      
      } // chiusura del ciclo switch
 
      // Serial.println("PTT status = ");
      // Serial.println(PTT_Status);
           
    } // chiusura del ciclo if

    delay(100); // era 1000
    ID_Radio++;

  } // chiusura del ciclo if di lettura del pulsante
 
 } // chiusura del ciclo if debouncer
  
// ------------- aggiunta

  Wire.beginTransmission(9); // transmit to device #9  
  Wire.write(ID_Radio);   // trasmette via I2C l'ID della radio selezionata 
  Wire.write(PTT_Status); // trasmette su I2C lo stato del PTT 
  
  Wire.endTransmission();    // fine trasmissione
  
// -------------

  unsigned long startMillis = millis();                    // start of sample window
  unsigned int PeaktoPeak = 0;                             // peak-to-peak level
  unsigned int SignalMax = 0;
  unsigned int SignalMin = Sensitivity;

  while ( millis() - startMillis < SampleWindow ) {

    sample = analogRead(analogInput);

    
    if (sample < Sensitivity) {

      if (sample > SignalMax) {

        SignalMax = sample;                                // saves just the max levels
      }

      else if (sample < SignalMin) {

        SignalMin = sample;                                // saves just the min levels
      }
    }
  }

  PeaktoPeak = SignalMax - SignalMin;                      // max - min = peak-peak amplitude
  float MeterValue = PeaktoPeak * 330 / Sensitivity;              // convert volts to arrow information

  MeterValue = MeterValue - 34;                            // shifts needle to zero position
  //myOLED.clrScr();                                // refresh display for next step
  myOLED.drawBitmap(0, 0, VUMeter, 128, 64);       // draws background
  int a1 = (hMeter + (sin(MeterValue / 57.296) * rMeter)); // meter needle horizontal coordinate
  int a2 = (vMeter - (cos(MeterValue / 57.296) * rMeter)); // meter needle vertical coordinate
  myOLED.drawLine(a1, a2, hMeter, vMeter);         // draws needle
  myOLED.update();

} // chiusura del ciclo loop
